#include "aopp.hpp"

using namespace AOPP;

AODriver::AODriver( int id ) :
    driver_id (id) {
    }

AOInfo * AODriver::driver_info( void ) {
    return ao_driver_info( driver_id );
    }

#if 0
// ao_file_extension not in my libao ?
const char * AODriver::file_extension( void ) {
    return ao_file_extension( driver_id );
    }
#endif

AODevice * AODriver::open_file( const char *filename, int overwrite, AOSampleFormat *format, AOOptions *options ) {
    ao_device * dev = ao_open_file(
        driver_id, 
        filename,
        overwrite,
        static_cast<ao_sample_format *> (format),
        options->options
        );
    if ( dev ) {
        AODevice *d;
        *d = AODevice( dev );
        return d;
        }
    return NULL;
    }

AODevice * AODriver::open_live( AOSampleFormat *format, AOOptions *options ) {
    ao_device * dev = ao_open_live(
        driver_id,
        static_cast<ao_sample_format *> (format),
        options->options
        );
    if ( dev ) {
        AODevice *d;
        d = new AODevice( dev );
        return d;
        }
    return NULL;
    }

int AODriver::get_driver_id( const char *short_name ) {
    return ao_driver_id( short_name );
    }
